# -*- coding: shift_jis -*-
#
#
# RSStB[hHTML̎擾ÁB
# Copyright (c) 2006,2007 Takehiro Ihara.
# Copyright (c) 2006,2007 Satoshi Fukutomi.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
package Trend::Agent;

require v5.8.0;
use warnings;
use strict;
use IO::File;
use Digest::MD5;
use LWP::UserAgent;

#
# RXgN^B
#
sub new($$) {
    my $self = shift(@_);
    my $uri = shift(@_);
    my $ctx = Digest::MD5->new();
    $ctx->add($uri);
    my $cache = sprintf('%s/%s', $Trend::Config::cache_dir, $ctx->hexdigest);
    return bless({uri => $uri,
                  cache => $cache});
}

#
# 擾B
# LbVt@C΁AgƂɂB
#
sub download($) {
    my $self = shift(@_);
    if (-f $self->{cache}) {
        printf("Loding cached %s.\n", $self->{uri});
        return $self->loadCache();
    }
    my $ua = LWP::UserAgent->new();
    printf('Downloding %s ... ', $self->{uri});
    my $request = HTTP::Request->new('GET', $self->{uri});
    my $response = $ua->request($request);
    if ($response->is_success()) {
        $self->{content} = $response->content();
        $self->syncCache();
        print "done.\n";
        return 1;
    } else {
        print "ERROR.\n";
        return 0;
    }
}

#
# LbVt@CɕۑB
#
sub syncCache($) {
    my $self = shift(@_);
    my $output = IO::File->new($self->{cache}, 'w');
    $output->print($self->{content});
    $output->close();
    return 1;
}

#
# LbVt@C̓ǂݍ݁B
# ǂԂB
#
sub loadCache($) {
    my $self = shift(@_);
    if (-f $self->{cache}) {
        my $input = IO::File->new($self->{cache});
        $self->{content} = join('', $input->getlines());
        $input->close();
        return 1;
    } else {
        return 0;
    }
}

1;
