# -*- coding: shift_jis -*-
#
# RSStB[h̎擾ÁB
#
# Copyright (c) 2006,2007 Takehiro Ihara.
# Copyright (c) 2006,2007 Satoshi Fukutomi.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
package Trend::Feed;

require v5.8.0;
use warnings;
use strict;
use XML::DOM;

use Trend::Agent;

our @ISA = ('Trend::Agent');

#
# RXgN^B
#
sub new($$) {
    my $self = shift(@_);
    my $uri = shift(@_);
    return bless(Trend::Agent->new($uri));
}


#
# RSStB[h͂item̎wvf(eLXgm[h)ԂB
#
sub getItemChildren($$) {
    my $self = shift(@_);
    my $tagName = shift(@_);
    my $parser = XML::DOM::Parser->new();
    my $doc = $parser->parse($self->{content});
    my @items = $doc->getElementsByTagName('item');
    my $item;
    my @buf = ();
    foreach $item (@items) {
        my @desc = $item->getElementsByTagName($tagName);
        push(@buf, $desc[0]->getFirstChild()->getNodeValue());
    }
    return @buf;
}

#
# RSStB[h͂itemdescriptionԂB
# Ⴆ΂͂ĂȂ̃L[[hB
#
sub getDescriptions($) {
    my $self = shift(@_);
    return $self->getItemChildren('description');
}

#
# RSStB[h͂itemlinkԂB
#
sub getLinks($) {
    my $self = shift(@_);
    return $self->getItemChildren('link');
}

1;
