# -*- coding: shift_jis -*-
#
# JumañC^[tF[XB
#
# Copyright (c) 2006,2007 Takehiro Ihara.
# Copyright (c) 2006,2007 Satoshi Fukutomi.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
package Trend::Juman;

require v5.8.0;
use warnings;
use strict;
use Encode;
use IO::File;
use IO::Pipe;

use Trend::Config;

#
# RXgN^B
#
sub new($) {
    my $self = shift(@_);
    return bless({tmpfile => $Trend::Config::juman_tmpfile,
                  strings => [],
                  cache => {}});
}

#
# ƂŌ`ԑf͂邽߂ɓo^ĂB
#
sub push($$) {
    my $self = shift(@_);
    my $string = shift(@_);
    CORE::push(@{$self->{strings}}, $string);
}

#
# JumanNA`ԑf͂ALbVB
#
sub run($) {
    my $self = shift(@_);
    #my $pipe = IO::Pipe->new();
    #$pipe->writer(sprintf('juman > %s', $self->{tmpfile}));
    my $pipe;
    open($pipe, sprintf('| juman > %s', $self->{tmpfile}));
    foreach my $string_uni (@{$self->{strings}}) {
        my $string = $string_uni;
        $string =~ s/\n//g;
        $string =~ s/$Trend::Config::spec_string//g;
        $string = encode($Trend::Config::juman_coding, $string);
        #$pipe->print($string, "\n");
        print $pipe $string, "\n";
    }
    #$pipe->close();
    close($pipe);
    my $input = IO::File->new($self->{tmpfile});
    my $i = 0;
    my @words = ();
    foreach my $line ($input->getlines()) {
        my @col = split(/ /, $line);
        if ($line eq "EOS\n") {
            $self->{cache}{$self->{strings}[$i]} = [@words];
            $i += 1;
            @words = ();
        } elsif ($col[0] =~ /$Trend::Config::spec_word/) {
            next;
        } else {
            foreach my $c (@col) {
                $c = decode($Trend::Config::juman_coding, $c);
            }
            CORE::push(@words, {appear => $col[0],        # o`
                                base => $col[2],          # {`
                                pos => $col[3],           # i
                                spos => $col[4]},         # iו
            );
        }
    }
    $input->close();
    return;
}

#
# `ԑf͂B
#
sub parse($$) {
    my $self = shift(@_);
    my $string = shift(@_);
    if (! %{$self->{cache}}) {
        $self->run();
    }
    my $tmp = $self->{cache}{$string};
    if (! $tmp) {
        die(sprintf('Juman Error: %s', $string));
    }
    return @{$tmp};
}

1;
