# -*- coding: shift_jis -*-
#
# t@CɕۑĂXgB
# Tie::File ݂Ȃ́B
#
# Copyright (c) 2006,2007 Takehiro Ihara.
# Copyright (c) 2006,2007 Satoshi Fukutomi.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
package Trend::ListFile;

require v5.8.0;
use warnings;
use strict;
use Encode;
use IO::File;


#
# RXgN^B
#
sub new($$) {
    my $self = shift(@_);
    my $filename = shift(@_);
    $self = bless({filename => $filename,
                   data => [],
                   index => {}});
    $self->load();
    return $self;
}

#
# ǂݍ݁B
#
sub load($) {
    my $self = shift(@_);
    if (-e $self->{filename}) {
        my $input = IO::File->new($self->{filename});
        foreach my $line ($input->getlines()) {
            chomp($line);
            $line = decode('utf8', $line);
            push(@{$self->{data}}, $line);
            $self->{index}{$line} = 1;
        }
        $input->close();
    }
}

#
# ۑB
#
sub sync($) {
    my $self = shift(@_);
    my $output = IO::File->new($self->{filename}, 'w');
    local $_;
    foreach (@{$self->{data}}) {
        $output->printf("%s\n", encode('utf8', $_));
    }

}

#
# ؂l߁B
#
sub cut($$) {
    my $self = shift(@_);
    my $size = shift(@_);
    while ($size < @{$self->{data}}) {
        my $element = shift(@{$self->{data}});
        delete($self->{index}{$element});
    }
}

#
# ǉB
#
sub push($$) {
    my $self = shift(@_);
    my $element = shift(@_);
    push(@{$self->{data}}, $element);
    $self->{index}{$element} = 1;
}

#
# vfĂ邩ǂB
#
sub includes($$) {
    my $self = shift(@_);
    my $element = shift(@_);
    return $self->{index}{$element};
}

1;
