# -*- coding: shift_jis -*-
#
# w肵ŕוςB
#
# Copyright (c) 2006,2007 Takehiro Ihara.
# Copyright (c) 2006,2007 Satoshi Fukutomi.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
package Trend::Sort;

require v5.8.0;
use warnings;
use strict;

#
# RXgN^B
#
sub new($) {
    my $self = shift(@_);
    return bless({});
}

#
# eɃXRAB
#
# dv: E` 
# O: w肵P + XRA̍P
#
# dṽXRA = o-1
# ÕXRA = -XRA
# ̃XRA = ̑SĂ̒P̃XRA - yieB*̒
#
sub score($$%) {
    my $self = shift(@_);
    my $sentences = shift(@_);
    my %opt = @_;
    my $keywords = $opt{keywords};
    my $except = $opt{except} || [];
    my $penalty = $opt{penalty};
    my $sentence;
    my %except = ();
    my %wordScore = ();

    # Oꂪ΂̏B
    foreach my $word (@{$except}) {
        $except{$word} = 1;
    }

    # o񐔂𐔂B
    foreach $sentence (@{$sentences}) {
        foreach my $word (@{$sentence->{words}}) {
            if (($word->{pos} =~ /$Trend::Config::pos_important/) &&
                ($word->{spos} !~ /$Trend::Config::spos_except/)) {
                $wordScore{$word->{appear}} += 1;
            }
        }
        foreach my $word (keys(%except)) {
            my $n = $sentence=~/\Q$word\E/g;
            $wordScore{$word} += 1;
        }
    }

    # dvXRA = o - 1
    foreach my $word (keys(%wordScore)) {
        $wordScore{$word} -= 1;
    }

    # Oo񐔂̑P̓XRA𔽓]B
    WORD_SCORE: foreach my $word (keys(%wordScore)) {
        foreach my $exceptWord (keys(%except)) {
            if ((! $except{$word}) &&
                ($wordScore{$exceptWord}) &&
                ($wordScore{$exceptWord} < $wordScore{$word})) {
                $wordScore{$word} *= -1;
                next WORD_SCORE;
            }
        }
    }

    # O̓XRA𔽓]B
    foreach my $word (keys(%except)) {
        if ($wordScore{$word}) {
            $wordScore{$word} *= -1;
        }
    }

    # ̃XRAvZB
    foreach $sentence (@{$sentences}) {
        $sentence->{score} = 0;
        foreach my $word (keys(%wordScore)) {
            if ($sentence->{string} =~ /\Q$word\E/) {
                $sentence->{score} += $wordScore{$word};
            }
        }
        $sentence->{score} -= $penalty * length($sentence->{string});
    }

    # ֘AvẐ߂ɃL[[hEdvxXRALbVĂB
    $self->{keywords} = $keywords;
    $self->{wordScore} = \%wordScore;
    return @{$sentences};
}

#
# Ŏw肵ŊeXRAÂA
# XRA̍~ɕׂĕԂB
# XRA͕ۑȂB
#
sub sort($$%) {
    my $self = shift(@_);
    my $paragraphs = shift(@_);
    my %opt = @_;
    my $keywords = $opt{keywords};

    # ȍ~̓L[[h܂ޒi̕ΏہB
    my @sentences = ();
    PARAGRAPH: foreach my $paragraph (@{$paragraphs}) {
        foreach my $sentence (@{$paragraph}) {
            foreach my $key (@{$keywords}) {
                if ($sentence->{string}=~/\Q$key\E/) {
                    push(@sentences, @{$paragraph});
                    next PARAGRAPH;
                }
            }
        }
    }
    $self->score(\@sentences, %opt);
    @sentences = sort {$b->{score} <=> $a->{score}} @sentences;
    return \@sentences;
}

#
# ֘AԂB
# ֘AƂ͎2̏𓯎ɖPB
#       EL[[h܂ޕ̏WŁAo񐔂
#       EL[[ḧꕔłȂAL[[h܂ނ̂łȂ
#
sub relatedWords($$) {
    my $self = shift(@_);
    my $size = shift(@_);
    my @words = ();
    CHECK: foreach my $word (keys(%{$self->{wordScore}})) {
        foreach my $key (@{$self->{keywords}}) {
            if (($word =~ /\Q$key\E/) || ($key =~ /\Q$word\E/)) {
                next CHECK;
            }
        }
        push(@words, $word);
    }
    @words = sort {$self->{wordScore}{$b} <=> $self->{wordScore}{$a}} @words;
    $size = ($size < @words)? $size: $#words;
    return [@words[0 .. $size]];
}


1;
