# -*- coding: shift_jis -*-
#
# Rsygh̑fɂȂLB
#
# Copyright (c) 2006,2007 Takehiro Ihara.
# Copyright (c) 2006,2007 Satoshi Fukutomi.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
package Trend::Source;

require v5.8.0;
use warnings;
use strict;
use Encode;

use Trend::Config;
use Trend::Agent;
use Trend::Juman;

our @ISA = ('Trend::Agent');

#
# RXgN^B
#
sub new($$) {
    my $self = shift(@_);
    my $uri = shift(@_);
    return bless(Trend::Agent->new($uri));
}

#
# AGXP[vB
#
sub unescape($$) {
    my $self = shift(@_);
    my $string = shift(@_);
    $string =~ s/&lt;/</g;
    $string =~ s/&gt;/>/g;
    $string =~ s/&amp;/&/g;
    return $string;
}

#
# ^OAvCeLXgɂB
#
# Ƃ̏:
#       <div class="section">
#           <h3>^Cg</h3>
#           <p>{</p>
#           <p>{</p>
#           <p>{</p>
#       </div>
#
# eLXg̃f[^\:
#       Source = (L, L, ...)
#       L = (i, i, ...)
#       i = (, ,...)
#
sub parseHTML($$) {
    my $self = shift(@_);
    $self->{juman} = Trend::Juman->new();
    $self->{sections} = [];
    my $dot = $Trend::Config::char_dot;
    # XXX ̏́u͂Ăȃ_CA[v̏ɈˑB
    my $coding = $Trend::Config::html_coding;
    my $state = 0;
    my $paragraphs = [];
    foreach my $line (split(/\n+/, $self->{content})) {
        if ($line eq "\t\t<div class=\"section\">") {
            # LJnB
            $state = 1;
        } elsif ($line eq "\t\t</div>") {
            # LIB
            $state = 0;
            push(@{$self->{sections}}, $paragraphs);
            $paragraphs = [];
        } elsif ($line =~ /<p class="sectionfooter">/) {
            # pass
        } elsif ($state == 1) {
            $line =~ s/<.*?>//g;
            $line = decode($coding, $line);
            my $sentences = [];
            foreach my $sentence (split /$dot/, $line) {
                $sentence =~ s/^\s*//;
                $sentence = $self->unescape($sentence);
                if ($sentence) {
                    $self->{juman}->push($sentence);
                    push(@{$sentences}, $sentence);
                }
            }
            push(@{$paragraphs}, $sentences);
        }
    }
    return @{$self->{sections}};
}

#
# L[[h܂ދL𒊏oB
#
sub selectSections($$) {
    my $self = shift(@_);
    my $keyword = shift(@_);
    my @buf = ();
    SECTION: foreach my $section (@{$self->{sections}}) {
        foreach my $paragraph (@{$section}) {
            foreach my $sentence (@{$paragraph}) {
                if ($sentence =~ /\Q$keyword\E/) {
                    push(@buf, $section);
                    next SECTION;
                }
            }
        }
    }
    $self->{sections} = \@buf;
    return @buf;
}

#
# `ԑf͂ALiɕB
#
# i = (, , ...)
#
# ̏:
#       E`
#       EJumanŉ͂f[^\
#       ELURI
#
sub getParagraphs($) {
    my $self = shift(@_);
    my @paragraphs = ();
    foreach my $section (@{$self->{sections}}) {
        foreach my $paragraph (@{$section}) {
            my $sentences = [];
            foreach my $sentence (@{$paragraph}) {
                my @words = $self->{juman}->parse($sentence);
                push(@{$sentences}, {string => $sentence,
                                  words => [@words],
                                  uri => $self->{uri}});
            }
            push(@paragraphs, $sentences);
        }
    }
    return @paragraphs;
}

1;
