#!c:/perl/bin/perl
#
# -*- coding: shift_jis -*-
#
# Rsygh
#
# eTuvOsB
# R[hAsR[hWindowsɐݒ肵ĂB
#
# Copyright (c) 2006,2007 Takehiro Ihara.
# Copyright (c) 2006,2007 Satoshi Fukutomi.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
require v5.8.0;
use warnings;
use strict;
use Encode;
use IO::File;

use Trend::Config;
use Trend::Feed;
use Trend::ListFile;
use Trend::Article;

#
# CB
#
sub main() {
    binmode STDOUT, sprintf(':encoding(%s)', $Trend::Config::terminal_coding);
    binmode STDERR, sprintf(':encoding(%s)', $Trend::Config::terminal_coding);

    # fBNg̏B
    mkdir($Trend::Config::cache_dir, 0777);
    mkdir($Trend::Config::run_dir, 0777);
    mkdir($Trend::Config::working_dir, 0777);
    mkdir($Trend::Config::output_dir, 0777);
    mkdir($Trend::Config::dump_dir, 0777);

    my @time = localtime();
    my $output = IO::File->new(sprintf('%s/%d-%02d-%02d',
                                       $Trend::Config::output_dir,
                                       1900+$time[5], 1+$time[4], $time[3]),
                               'a');

    # L[[hꗗ̎擾B
    my $feed = Trend::Feed->new($Trend::Config::keywords);
    $feed->download();
    my @keywords =  $feed->getDescriptions();

    # eL[[hɂēL𐶐B
    # xgL[[h͎gȂB
    my $usedKeywords = Trend::ListFile->new($Trend::Config::used_keywords);
    my $ii = $Trend::Config::section_num;
    foreach my $keyword (@keywords) {
        if (! $usedKeywords->includes($keyword)) {
            printf "%s\n", $keyword;
            my $article = Trend::Article->new($keyword);
            $article->getSources();
            $article->selectSentences();
            $article->summary();
            if ($article->check()) {
                $article->write($output);
            }
            $usedKeywords->push($keyword);
            $ii -= 1;
            if ($ii <= 0) {
                last;
            }
        }
    }

    # L[[hXg̕ۑB
    if ($Trend::Config::save_keywords) {
        $usedKeywords->cut($Trend::Config::used_keywords_num);
        $usedKeywords->sync();
    }
}

main();
